unit HauptFormular;

interface

uses
	miscfunc, misctype, RakTree, RakBinaryStreamData, RakBinaryStreamDataXML,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ExtDlgs, jpeg, ActnList, Menus;

type
  TMainForm = class(TForm)
    Rtr: TRakTree;
    Odg: TOpenDialog;
    Sdg: TSaveDialog;
    Nbk: TNotebook;
    Label1: TLabel;
    EdtAppName: TEdit;
    Label2: TLabel;
    EdtAppVersion: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    EdtTagName: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label6: TLabel;
    Label7: TLabel;
    EdtAttrName: TEdit;
    Label9: TLabel;
    EdtType: TEdit;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    CbxNewDataType: TComboBox;
    Button3: TButton;
    Button4: TButton;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    CbxTopDataType: TComboBox;
    Button5: TButton;
    BtnDelAttr: TButton;
    Label13: TLabel;
    EdtTopAttrName: TEdit;
    Label15: TLabel;
    EdtNewAttrName: TEdit;
    OpdGraphic: TOpenPictureDialog;
    OpdJpeg: TOpenPictureDialog;
    CckIsNull: TCheckBox;
    PnlValue: TPanel;
    Label8: TLabel;
    NbkValue: TNotebook;
    EdtValue: TEdit;
    Button7: TButton;
    ImgGraphic: TImage;
    CckScale: TCheckBox;
    Panel2: TPanel;
    ScbBlob: TScrollBar;
    PnlBlob: TPanel;
    Pbx: TPaintBox;
    PnlData: TPanel;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Saveas1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    ActionList1: TActionList;
    ActNew: TAction;
    ActOpen: TAction;
    ActSaveAs: TAction;
    N2: TMenuItem;
    XML1: TMenuItem;
    MnuXmlSaveAs: TMenuItem;
    MnuXmlOpen: TMenuItem;
    OdgXml: TOpenDialog;
    SdgXml: TSaveDialog;
    ImgBild: TImage;
    BtnLoadPicture: TButton;
    OpdBild: TOpenPictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure RtrFocusedNodeChanged(Sender: TObject;
      OldNode: TRakTreeNode);
    procedure EdtAppNameChange(Sender: TObject);
    procedure EdtAppVersionChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure EdtTagNameChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure EdtAttrNameExit(Sender: TObject);
    procedure EdtValueExit(Sender: TObject);
    procedure BtnDelAttrClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PbxPaint(Sender: TObject);
    procedure CckIsNullClick(Sender: TObject);
    procedure CckScaleClick(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure ScbBlobChange(Sender: TObject);
    procedure PbxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PbxDblClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ActNewExecute(Sender: TObject);
    procedure ActOpenExecute(Sender: TObject);
    procedure ActSaveAsExecute(Sender: TObject);
    procedure MnuXmlOpenClick(Sender: TObject);
    procedure MnuXmlSaveAsClick(Sender: TObject);
    procedure BtnLoadPictureClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FSelIdx: Longword;

    procedure CheckEnabled;

    procedure AddAttr(Tag: TRakBinaryTag; DataType: TRakBinaryDataType; Name: string);
    procedure RebuildTree;
    function StreamData: TRakBinaryStreamData;

    procedure CalcImageSize;
    
    function FindRefObjNode(Node: TRakTreeNode; refObj: TObject): TRakTreeNode;
    procedure FocusTag(Tag: TRakBinaryTag);
    procedure FocusAttribute(Attr: TRakBinaryAttribute);
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

uses DlgChangeByte;

{$R *.DFM}

const
	HOEHE = 20;
  BREITE = 20;
  
procedure TMainForm.FormCreate(Sender: TObject);
var
  BinaryData: TRakBinaryStreamData;
  DataType: TRakBinaryDataType;
  i: integer;
begin
	Pbx.Parent.DoubleBuffered := true;
	BinaryData := TRakBinaryStreamData.Create;
	Rtr.Anker.DataObj := BinaryData;

  RebuildTree;

  for i := 1 to 20 do
  begin
  	DataType := TRakBinaryAttribute.DataTypeOf(i);
	  CbxTopDataType.Items.AddObject(DataType.ClassName, TObject(DataType));
    CbxNewDataType.Items.AddObject(DataType.ClassName, TObject(DataType));
  end;
  CbxTopDataType.Items.AddObject('TRakBinaryBitmap', TObject(TRakBinaryBitmap));
  CbxTopDataType.Items.AddObject('TRakBinaryIcon', TObject(TRakBinaryIcon));
  CbxTopDataType.Items.AddObject('TRakBinaryMetafile', TObject(TRakBinaryMetafile));
  CbxTopDataType.Items.AddObject('TRakBinaryJpeg', TObject(TRakBinaryJpeg));
  CbxTopDataType.ItemIndex := 0;

  CbxNewDataType.Items.AddObject('TRakBinaryBitmap', TObject(TRakBinaryBitmap));
  CbxNewDataType.Items.AddObject('TRakBinaryIcon', TObject(TRakBinaryIcon));
  CbxNewDataType.Items.AddObject('TRakBinaryMetafile', TObject(TRakBinaryMetafile));
  CbxNewDataType.Items.AddObject('TRakBinaryJpeg', TObject(TRakBinaryJpeg));
  CbxNewDataType.ItemIndex := 0;

  RtrFocusedNodeChanged(self, nil);
end;

procedure TMainForm.CheckEnabled;
var
  Item: TRakBinaryAttribute;
  Node: TRakTreeNode;
  bObj: TRakBinaryBlob;
begin
	Node := Rtr.FocusedNode;
	if Node = nil then
  	Nbk.Visible := false
  else
  begin
  	Nbk.Visible := true;

    if Node.refObj is TRakBinaryTag then
    begin
    	Nbk.ActivePage := 'Tag';
      EdtTagName.Text := TRakBinaryTag(Node.refObj).TagName;
    end
    else if Node.refObj is TRakBinaryAttribute then
    begin
    	Nbk.ActivePage := 'Attribute';
    	Item := TRakBinaryAttribute(Node.refObj);
      EdtType.Text := Item.DataTypeAsString;
      EdtAttrName.Text := Item.ItemName;
      CckIsNull.Checked := Item.IsNull;
      PnlValue.Visible := not Item.IsNull;
      if PnlValue.Visible then
      begin
        if Node.refObj is TRakBinaryGraphic then
        begin
          NbkValue.ActivePage := 'Graphic';
          if TRakBinaryGraphic(Item).Graphic <> nil then
            ImgGraphic.Picture.Graphic := TRakBinaryGraphic(Item).Graphic
          else
            ImgGraphic.Picture.Graphic := nil;
        end
        else if Node.refObj is TRakBinaryPicture then
        begin
          NbkValue.ActivePage := 'Picture';
          ImgBild.Picture.Graphic := TRakBinaryPicture(Item).Graphic;
          CalcImageSize;
        end
        else if Node.refObj is TRakBinaryBlob then
        begin
          NbkValue.ActivePage := 'Blob';
          Pbx.Invalidate;

			  	bObj := TRakBinaryBlob(Node.refObj);

          ScbBlob.Max := BigDiv(bObj.GetBinarySize, 16);
          FSelIdx := 0;
        end
        else
        begin
          NbkValue.ActivePage := 'AsString';
          EdtValue.Text := Item.AsWideString;
        end;
      end;
    end;
  end;
end;

procedure TMainForm.RebuildTree;
	procedure BuildTagZweig(Node: TRakTreeNode; Tag: TRakBinaryTag; IsOwner: boolean);
  var
    i: integer;
    NewNode: TRakTreeNode;
  begin
  	Node.Caption := Tag.TagName;
    if not IsOwner then
    	Node.refObj := Tag;
    for i := 0 to Tag.Attributes.Count - 1 do
    begin
    	NewNode := Node.Add;
      NewNode.Caption := Tag.Attributes[i].ItemName;
      NewNode.refObj := Tag.Attributes[i];
    end;

    for i := 0 to Tag.Count - 1 do
    	BuildTagZweig(Node.Add, Tag[i], false);
  end;
begin
	Rtr.Anker.FreeAll;
  BuildTagZweig(Rtr.Anker, TRakBinaryTag(Rtr.Anker.DataObj), true);
  EdtAppName.Text := TRakBinaryStreamData(Rtr.Anker.DataObj).ApplicationName;
  EdtAppVersion.Text := TRakBinaryStreamData(Rtr.Anker.DataObj).ApplicationVersion;
  CheckEnabled;
end;

procedure TMainForm.RtrFocusedNodeChanged(Sender: TObject;
  OldNode: TRakTreeNode);
begin
	CheckEnabled;
end;



procedure TMainForm.EdtAppNameChange(Sender: TObject);
begin
	StreamData.ApplicationName := EdtAppName.Text;
end;

function TMainForm.StreamData: TRakBinaryStreamData;
begin
	Result := TRakBinaryStreamData(Rtr.Anker.DataObj);
end;

procedure TMainForm.EdtAppVersionChange(Sender: TObject);
begin
	StreamData.ApplicationVersion := EdtAppVersion.Text;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
	Tag: TRakBinaryTag;
begin
	Tag := StreamData.AddTag;
  Tag.TagName := 'NewTag';
  RebuildTree;
  FocusTag(Tag);
end;

procedure TMainForm.Button5Click(Sender: TObject);
var
	DataType: TRakBinaryDataType;
begin
	DataType := TRakBinaryDataType(CbxTopDataType.Items.Objects[CbxTopDataType.ItemIndex]);
  AddAttr(StreamData, DataType, EdtTopAttrName.Text);
end;

procedure TMainForm.EdtTagNameChange(Sender: TObject);
var
  Node :TRakTreeNode;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
	  TRakBinaryTag(Node.refObj).TagName := EdtTagName.Text;
    Node.Caption := EdtTagName.Text;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
  Node :TRakTreeNode;
	Tag: TRakBinaryTag;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
	  Tag := TRakBinaryTag(Node.refObj).AddTag;
    Tag.Tagname := 'neuerUntertag';
    RebuildTree;
    FocusTag(Tag);
  end;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
	DataType: TRakBinaryDataType;
  Node :TRakTreeNode;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
    DataType := TRakBinaryDataType(CbxNewDataType.Items.Objects[CbxNewDataType.ItemIndex]);
    AddAttr(TRakBinaryTag(Node.refObj), DataType, EdtNewAttrName.Text);
  end;
end;

procedure TMainForm.EdtAttrNameExit(Sender: TObject);
var
  Node :TRakTreeNode;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
  	TRakBinaryAttribute(Node.refObj).ItemName := EdtAttrName.Text;
    Node.Caption := TRakBinaryAttribute(Node.refObj).ItemName;
  end;
end;

procedure TMainForm.EdtValueExit(Sender: TObject);
var
  Node :TRakTreeNode;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
  	TRakBinaryAttribute(Node.refObj).AsWideString := EdtValue.Text;
    CheckEnabled;
  end;
end;

procedure TMainForm.BtnDelAttrClick(Sender: TObject);
var
  Node :TRakTreeNode;
  Obj: TObject;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
  	Obj := Node.refObj;
    Node.Free;
  	Obj.Free;
  end;
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
  Node :TRakTreeNode;
  bObj, bObjNew: TRakBinaryGraphic;
  Graphic: TGraphic;
  ObjName: string;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
    if OpdGraphic.Execute then
    begin
      ImgGraphic.Picture.LoadFromFile(OpdGraphic.FileName);
      bObj := TRakBinaryGraphic(Node.refObj);
      Graphic := ImgGraphic.Picture.Graphic;
      if bObj.Graphic.ClassType = Graphic.ClassType then
      	bObj.Graphic := Graphic
      else
      begin
      	ObjName := bObj.ItemName;
      	if Graphic.ClassType = TBitmap then
	        bObjNew := TRakBinaryGraphic(bObj.Parent.Add(TRakBinaryBitmap))
      	else if Graphic.ClassType = TIcon then
	        bObjNew := TRakBinaryGraphic(bObj.Parent.Add(TRakBinaryIcon))
      	else if Graphic.ClassType = TMetafile then
	        bObjNew := TRakBinaryGraphic(bObj.Parent.Add(TRakBinaryMetafile))
      	else if Graphic.ClassType = TJPEGImage then
	        bObjNew := TRakBinaryGraphic(bObj.Parent.Add(TRakBinaryJpeg))
        else
        begin
        	ShowMessage('Das Bild hat ein unbekanntes Format');
          bObjNew := nil;
        end;

        if bObjNew <> nil then
        begin
          bObjNew.Index := bObj.Index;
          bObj.Free;
          bObjNew.ItemName := ObjName;
          RebuildTree;
          bObjNew.Graphic := Graphic;
          FocusAttribute(bObjNew);
          ShowMessage('Das Attribute musste seinen Typ ndern.');
        end;
      end;
    end;
  end;
end;

procedure TMainForm.FocusTag(Tag: TRakBinaryTag);
var
	Node: TRakTreeNode;
begin
  Node := FindRefObjNode(Rtr.Anker, Tag);
  if Node <> nil then
  begin
  	Node.Visible := true;
  	Rtr.FocusedNode := Node;
  end;
end;

function TMainForm.FindRefObjNode(Node: TRakTreeNode;
  refObj: TObject): TRakTreeNode;
var
  i: integer;
begin
  if Node.refObj = refObj then
  	Result := Node
  else
  begin
    Result := nil;
    for i := 0 to Node.Count - 1 do
    begin
    	Result := FindRefObjNode(Node[i], refObj);
      if Result <> nil then
      	break;
    end;
  end;
end;

procedure TMainForm.FocusAttribute(Attr: TRakBinaryAttribute);
var
	Node: TRakTreeNode;
begin
  Node := FindRefObjNode(Rtr.Anker, Attr);
  if Node <> nil then
  begin
  	Node.Visible := true;
  	Rtr.FocusedNode := Node;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
	Rtr.Anker.FreeAll;
end;

procedure TMainForm.AddAttr(Tag: TRakBinaryTag; DataType: TRakBinaryDataType; Name: string);
var
  Attr: TRakBinaryAttribute;
begin
  Attr := nil;
  if DataType = TRakBinaryJpeg then
  begin
    if OpdJpeg.Execute then
    begin
    	ImgGraphic.Picture.LoadFromFile(OpdJpeg.FileName);
      if ImgGraphic.Picture.Graphic is TJPEGImage then
      begin
			  Attr := Tag.AddAttribute(TRakBinaryJpeg, Name);
        TRakBinaryJpeg(Attr).Graphic := ImgGraphic.Picture.Graphic;
      end;
    end;
  end
  else
	  Attr := Tag.AddAttribute(DataType, Name);

  if Attr <> nil then
  begin
	  RebuildTree;
	  FocusAttribute(Attr);
  end;
end;

procedure TMainForm.PbxPaint(Sender: TObject);
  procedure DrawHex(X, Y: integer; A: byte);
  var
  	HexZahl: string;
    Zahl: integer;
  begin
  	setlength(HexZahl, 2);
  	Zahl := A div 16;
    if Zahl > 9 then
	    HexZahl[1] := Char(Zahl - 10 + Ord('A'))
    else
	    HexZahl[1] := Char(Zahl + Ord('0'));

  	Zahl := A mod 16;
    if Zahl > 9 then
	    HexZahl[2] := Char(Zahl - 10 + Ord('A'))
    else
	    HexZahl[2] := Char(Zahl + Ord('0'));

    Pbx.Canvas.TextOut(X * BREITE, Y * HOEHE, HexZahl);
  end;
var
	Stream: TMemoryStream;
  Puffer: array[0..16] of char;
  Len: integer;
  X, Y, YOff, SelX: integer;
  Node :TRakTreeNode;
  bObj: TRakBinaryBlob;
begin
	InitCanvas(Pbx.Canvas);
  Pbx.Canvas.Brush.Style := bsSolid;
  Pbx.Canvas.Font := Pbx.Font;
	Node := Rtr.FocusedNode;
  if (Node <> nil) and (Node.refObj is TRakBinaryBlob) then
  begin
  	bObj := TRakBinaryBlob(Node.refObj);

		Stream := TMemoryStream.Create;
    try
    	Stream.Size := bObj.GetBinarySize;
      bObj.GetAsBinary(Stream.Memory, Stream.Size);

    	YOff := ScbBlob.Position;
    	Stream.Seek(YOff * 16, soFromBeginning);
      Y := 0;
    	repeat
      	SelX := FSelIdx - Longword(Stream.Position);
	    	Len := Stream.read(Puffer, 16);
        if Len > 0 then
        begin
          X := 0;
          while X < Len do
          begin
          	if SelX = X then
            	Pbx.Canvas.Brush.Color := clSilver
            else
            	Pbx.Canvas.Brush.Color := clWhite;
            DrawHex(X, Y, Ord(Puffer[X]));
            inc(X);
          end;
          Puffer[Len] := #0;
          Pbx.Canvas.Brush.Color := clWhite;
			    Pbx.Canvas.TextOut(16 * BREITE + 10, Y * HOEHE, Puffer);

          inc(Y);
        end;
      until (Len < 16) or (Y * HOEHE - HOEHE > Pbx.Height);
  	finally
    	Stream.Free;
    end;
  end;
end;

procedure TMainForm.CckIsNullClick(Sender: TObject);
var
	Node: TRakTreeNode;
  Attr: TRakBinaryAttribute;
begin
  Node := Rtr.FocusedNode;
  if (Node <> nil) and (Node.refObj is TRakBinaryAttribute) then
  begin
  	Attr := TRakBinaryAttribute(Node.refObj);
  	Attr.IsNull := CckIsNull.Checked;
  	CheckEnabled;
  end;
end;


procedure TMainForm.CckScaleClick(Sender: TObject);
begin
	ImgGraphic.Stretch := CckScale.Checked;
end;

procedure TMainForm.Panel2Resize(Sender: TObject);
begin
	ScbBlob.PageSize := Pbx.Height div 16;
  ScbBlob.LargeChange := ScbBlob.PageSize;
end;

procedure TMainForm.ScbBlobChange(Sender: TObject);
begin
	Pbx.Invalidate;
end;

procedure TMainForm.PbxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
	Idx: Longword;
  Node :TRakTreeNode;
begin
	Node := Rtr.FocusedNode;
  if (Node <> nil) and (Node.refObj is TRakBinaryBlob) then
  begin
		Idx := X div BREITE + (ScbBlob.Position + Y div HOEHE) * 16;
    if (Idx <> FSelIdx) and (Idx < TRakBinaryBlob(Node.refObj).GetBinarySize) then
    begin
    	FSelIdx := Idx;
      Pbx.Invalidate;
    end;
  end;
end;

procedure TMainForm.PbxDblClick(Sender: TObject);
var
  Node :TRakTreeNode;
begin
	Node := Rtr.FocusedNode;
  if (Node <> nil) and (Node.refObj is TRakBinaryBlob) then
  begin
    if FSelIdx < TRakBinaryBlob(Node.refObj).GetBinarySize then
    begin
    	FrmChangeByte.Wert := TRakBinaryBlob(Node.refObj).AByte[FSelIdx];
      if FrmChangeByte.ShowModal = mrOk then
      begin
      	Pbx.Invalidate;
        TRakBinaryBlob(Node.refObj).AByte[FSelIdx] := FrmChangeByte.Wert;
      end;
    end;
  end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
	Close();
end;

procedure TMainForm.ActNewExecute(Sender: TObject);
begin
	Rtr.Anker.FreeAll;
  Rtr.Anker.DataObj := TRakBinaryStreamData.Create;
  RebuildTree;
  CheckEnabled;
end;

procedure TMainForm.ActOpenExecute(Sender: TObject);
var
	BinaryData: TRakBinaryStreamData;
  Stream: TFileStream;
begin
	if Odg.Execute then
  begin
    BinaryData := TRakBinaryStreamData.Create;
  	Rtr.Anker.FreeAll;
    Rtr.Anker.DataObj := BinaryData;
    Stream := TFileStream.Create(Odg.FileName, fmOpenRead);
    try
	    BinaryData.LoadFromStream(Stream);
    finally
	    Stream.Free;
    end;
    RebuildTree;
	  CheckEnabled;
  end;
end;

procedure TMainForm.ActSaveAsExecute(Sender: TObject);
var
  Stream: TFileStream;
begin
	if Sdg.Execute then
  begin
  	Rtr.SetFocus;
	  Stream := TFileStream.Create(Sdg.FileName, fmCreate);
    try
	    TRakBinaryStreamData(Rtr.Anker.DataObj).SaveToStream(Stream);
    finally
	    Stream.Free;
    end;
  end;
end;

procedure TMainForm.MnuXmlOpenClick(Sender: TObject);
var
	BinaryData: TRakBinaryStreamData;
  Stream: TFileStream;
begin
	if OdgXml.Execute then
  begin
  	Screen.Cursor := crHourGlass;
    try
      BinaryData := TRakBinaryStreamData.Create;
      Rtr.Anker.FreeAll;
      Rtr.Anker.DataObj := BinaryData;
      Stream := TFileStream.Create(OdgXml.FileName, fmOpenRead);
      try
        XmlStreamToRakBinary(Stream, BinaryData);
      finally
        Stream.Free;
      end;
      RebuildTree;
      CheckEnabled;
    finally
    	Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TMainForm.MnuXmlSaveAsClick(Sender: TObject);
var
  Stream: TFileStream;
begin
	if SdgXml.Execute then
  begin
  	Rtr.SetFocus;
  	Screen.Cursor := crHourGlass;
    try
      Stream := TFileStream.Create(SdgXml.FileName, fmCreate);
      try
        RakBinaryToXmlStream(TRakBinaryStreamData(Rtr.Anker.DataObj), Stream);
      finally
        Stream.Free;
      end;
    finally
    	Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TMainForm.BtnLoadPictureClick(Sender: TObject);
var
  Node :TRakTreeNode;
  bObj: TRakBinaryPicture;
begin
	Node := Rtr.FocusedNode;
  if Node <> nil then
  begin
    if OpdBild.Execute then
    begin
      ImgBild.Picture.LoadFromFile(OpdBild.FileName);
      CalcImageSize;

	  	bObj := TRakBinaryPicture(Node.refObj);
      bObj.Graphic := ImgBild.Picture.Graphic;
    end;
  end;
end;

procedure TMainForm.CalcImageSize;
var
  Width, Height: integer;
begin
  Width := ImgBild.Picture.Width;
  Height := ImgBild.Picture.Height;
  FitRect(Width, Height, NbkValue.Width, NbkValue.Height - 50);
  ImgBild.Width := Width;
  ImgBild.Height := Height;
end;

end.
